using System;
using System.Collections;


namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 
	
	public class TableTree
	{
		private uint runCounter = 0; 
		private byte[,,] lstate ;
		private byte[,,] lstateBack ;
		private Point[,,] pointSet;
		int borderLenght;
		private ArrayList toDoList=new ArrayList();
		private ArrayList toDoListBack;
		private class Point
		{
			public Point(int x, int y, int z)
			{ 
				this.x=x;
				this.y=y;
				this.z=z;
			}
			public int x;
			public int y;
			public int z;
		}


				

		public TableTree(int borderLenght)
		{
			this.borderLenght=borderLenght;
			lstate = new byte[borderLenght,borderLenght,borderLenght];
			pointSet= new Point[borderLenght,borderLenght,borderLenght];

			for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						pointSet[i,j,k]=new Point(i,j,k);
						lstate[i,j,k] = 0;
					}
				}
			}
			lstate[0,0,0] = 1;
			for(int i=-1;i<2;i++)
			{
				for(int j=-1;j<2;j++)
				{
					for(int k=-1;k<2;k++)
					{
						
					  toDoList.Add(pointSet[(i+borderLenght)%borderLenght,(j+borderLenght)%borderLenght,(k+borderLenght)%borderLenght]);
						
					}
				}
			}

		}
		


		public void CycleStart()
		{
			byte[,,] neigField=new byte[3,3,3];
			lstateBack=(byte [,,] )lstate.Clone();
			toDoListBack=(ArrayList)toDoList.Clone();
			bool changed=false;
			int i;
			int j;
			int k;
			int index;
						
			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();
		
			foreach(Object member in toDoListBack)
			{
            Point p=(Point)member;	
            changed=false;			
						neighbourfield(p.x, p.y, p.z, ref neigField);
						Update(p.x, p.y, p.z, ref neigField, ref changed);
						if (changed)
						{
							for(i=-1;i<2;i++)
							{
								for(j=-1;j<2;j++)
								{
									for(k=-1;k<2;k++)
									{
										if(!((i==0)&&(j==0)&&(j==0)))
										{
										   toDoList.Add(pointSet[(p.x+i+borderLenght)%borderLenght,(p.y+j+borderLenght)%borderLenght,(p.z+k+borderLenght)%borderLenght]);
										}
									}
								}
							}
						}
						
			}
			for(i=0;i<toDoList.Count;i++)
			{
				bool repeat=true;
				while(repeat)
				{
					index=toDoList.LastIndexOf(toDoList[i]);
					if (index>i)
					{
						toDoList.RemoveAt(index);
					}
					else
					{
						repeat=false;
					}
				}
			}
			
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			
			runCounter++;
		}

		

		

		
		private void neighbourfield(int x, int y, int z, ref byte[,,] neigField)
		{
			int xo = x + borderLenght;
			int yo = y + borderLenght;
			int zo = z + borderLenght;
			for(int i=-1;i<2;i++)
			{
				for(int j=-1;j<2;j++)
				{
					for(int k=-1;k<2;k++)
					{
						 neigField[i+1,j+1,k+1]=lstateBack[(xo+i)%borderLenght,(yo+j)%borderLenght,(zo+k)%borderLenght];
					}
				}
			}
	
		}
		void Update(int x, int y, int z, ref byte[,,] neigField, ref bool changed)

		{		
			int count =0; 
			for(int i=0;i<3;i++)
				for(int j=0;j<3;j++)
					for(int k=0;k<3;k++)
					{
						if (neigField[i,j,k]>=0)
						{
							count++;
						}
					}
			if(count> 0)
			{
				lstate[x,y,z]= 1;
							}
			else 
			{
				lstate[x,y,z]= 0;
		  }
		  if (lstateBack[x,y,z]!=lstate[x,y,z])
				changed=true;
		}
	}
}



