using System;
using System.Collections;


namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 
	
	public class TableTree
	{
		public uint runCounter = 0; 
		public CellLeaf[,,] leafs ;
		uint current;
		uint neu;
		int borderLenght;


				

		public TableTree(int borderLenght)
		{
			this.borderLenght=borderLenght;
			leafs = new CellLeaf[borderLenght,borderLenght,borderLenght];
			for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						 
						leafs[i,j,k] = new CellLeaf();
					}
				}
			}
		}
		


		public void CycleStart()
		{
			CellLeaf[,,] neigField=new CellLeaf[3,3,3];
			neu = (runCounter%2+1)%2;
			current=runCounter%2;

			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();
				
			for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						neighbourfield(i,j,k, ref neigField);
						Update(ref neigField);
					}
				}
			}
			
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			
			runCounter++;
		}

		

		

		
		private void neighbourfield(int x, int y, int z, ref CellLeaf[,,] neigField)
		{
			int xo = x + borderLenght;
			int yo = y + borderLenght;
			int zo = z + borderLenght;
			for(int i=-1;i<2;i++)
			{
				for(int j=-1;j<2;j++)
				{
					for(int k=-1;k<2;k++)
					{
						 neigField[i+1,j+1,k+1]=leafs[(xo+i)%borderLenght,(yo+j)%borderLenght,(zo+k)%borderLenght];
					}
				}
			}
	
		}
		private void Update(ref CellLeaf[,,] neigField)

		{		
			int count =0; 
			for(int i=0;i<3;i++)
				for(int j=0;j<3;j++)
					for(int k=0;k<3;k++)
					{
						if (neigField[i,j,k].state[current])
						{
							count++;
						}
					}
			if(count> 0)
			{
				neigField[1,1,1].state[neu]= true;
			}
			else 
			{
				neigField[1,1,1].state[neu] = false;
		    }

		}
	}
}



