using System;
using System.Collections;


namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 
	
	public class TableTree
	{
		public ushort runCounter = 8; 
		public CellNode[][,,] nodeBaum ;
		public CellLeaf[,,] leafs ;
		public int baumtiefe = 0;
		//private bool[,,] childs = new bool[2,2,2];
		private delegate void NeibConnectios (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs);
		private NeibConnectios conections;

		public TableTree(int baumtiefe)
		{
			int borderLenght;
			this.baumtiefe = baumtiefe;
			nodeBaum = new CellNode [baumtiefe][,,] ;
			

			
			conections += new NeibConnectios(CheckNeiBBordBottonBack);
			conections += new NeibConnectios(CheckNeiBBordBottonFront);
			conections += new NeibConnectios(CheckNeiBBordLeftBack);
			conections += new NeibConnectios(CheckNeiBBordLeftBotton);
			conections += new NeibConnectios(CheckNeiBBordLeftFront);
			conections += new NeibConnectios(CheckNeiBBordLeftTop);
			conections += new NeibConnectios(CheckNeiBBordRightBack);
			conections += new NeibConnectios(CheckNeiBBordRightBotton);
			conections += new NeibConnectios(CheckNeiBBordRightFront);
			conections += new NeibConnectios(CheckNeiBBordRightTop);
			conections += new NeibConnectios(CheckNeiBBordTopBack);
			conections += new NeibConnectios(CheckNeiBBordTopFront);
			
			conections += new NeibConnectios(CheckNeiBCorLeftBottonBack);
			conections += new NeibConnectios(CheckNeiBCorLeftBottonFront);
			conections += new NeibConnectios(CheckNeiBCorLeftTopBack);
			conections += new NeibConnectios(CheckNeiBCornLeftTopFront);
			conections += new NeibConnectios(CheckNeiBCorRightBottonBack);
			conections += new NeibConnectios(CheckNeiBCorRightBottonFront);
			conections += new NeibConnectios(CheckNeiBCorRightTopBack);
			conections += new NeibConnectios(CheckNeiBCroRightTopFront);
			conections += new NeibConnectios(CheckNeiBLeft);
			conections += new NeibConnectios(CheckNeiBRight);
			conections += new NeibConnectios(CheckNeiBTop);
			conections += new NeibConnectios(CheckNeiBFront);
			conections += new NeibConnectios(CheckNeiBBack);
			conections += new NeibConnectios(CheckNeiBBotton);
			
			
			for (int level=0; level<this.baumtiefe; level++)
			{
				borderLenght = (int)System.Math.Pow(2,level);
				nodeBaum[level] = new CellNode[borderLenght,borderLenght,borderLenght];
				//Console.WriteLine(nodeBaum[0][0,0,0].changed[0]);
				//Console.ReadLine();
				for (int i=0; i< borderLenght; i++)
				{
					for (int j=0; j< borderLenght; j++)
					{
						for (int k=0; k< borderLenght; k++)
						{
							nodeBaum[level][i,j,k] = new CellNode();
						}
					}
				}
			}
			borderLenght = (int)System.Math.Pow(2,this.baumtiefe);
			leafs = new CellLeaf[borderLenght,borderLenght,borderLenght];
			for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						 
						leafs[i,j,k] = new CellLeaf();
					}
				}
			}
			
			
		}

		


		public bool CycleStart()
		{
			int borderLenght;
			bool changed=false;
			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();
					
			MoveDown(0,0,0,0,ref changed);
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			//Console.ReadLine();
			/*for (int level=0; level<baumtiefe; level++)
			{
				borderLenght = (int)System.Math.Pow(2,level);
				for (int i=0; i< borderLenght; i++)
				{
					for (int j=0; j< borderLenght; j++)
					{
						Console.Write(level+" "+i+" "+j+" ");
						for (int k=0; k< borderLenght; k++)
						{
							if(nodeBaum[level][i,j,k].lastChange0>=nodeBaum[level][i,j,k].lastChange1)
							{
								Console.Write(+k+" "+"("+(nodeBaum[level][i,j,k].touchTimeStamp==nodeBaum[level][i,j,k].lastChange0)+") ");
							}
							else
							{
								Console.Write(+k+" "+"("+(nodeBaum[level][i,j,k].touchTimeStamp==nodeBaum[level][i,j,k].lastChange1)+") ");
							}

						
						}
						Console.WriteLine();
					}
					Console.WriteLine();
					Console.ReadLine();
				}
			}
			borderLenght = (int)System.Math.Pow(2,baumtiefe);
			for (int i=0; i< borderLenght; i++)
			{
				
				for (int j=0; j< borderLenght; j++)
				{
					Console.Write(i+" "+j+" ");
					for (int k=0; k< borderLenght; k++)
					{
						if((leafs[i,j,k].lastChange0==leafs[i,j,k].touchTimeStamp)
							||(leafs[i,j,k].lastChange1==leafs[i,j,k].touchTimeStamp))
						{
							if(leafs[i,j,k].lastChange0>=leafs[i,j,k].lastChange1)
							{
								Console.Write(+k+" "+"("+(leafs[i,j,k].touchTimeStamp-7)+") ");
							}
							else
								Console.Write(+k+" "+"("+(leafs[i,j,k].touchTimeStamp-7)+") ");
						}
						
					}
					Console.WriteLine();
				}
				Console.WriteLine();
				Console.ReadLine();
			}*/

			if(++runCounter==0)
			{  
				runCounter=8;
				for (int level=0; level<baumtiefe; level++)
				{
					borderLenght = (int)System.Math.Pow(2,level);
					for (int i=0; i< borderLenght; i++)
					{
						for (int j=0; j< borderLenght; j++)
						{
							for (int k=0; k< borderLenght; k++)
							{
								nodeBaum[level][i,j,k].lastChange0=0;
								nodeBaum[level][i,j,k].lastChange1=7;
								nodeBaum[level][i,j,k].touchTimeStamp=7;
							}
						}
					}
				}
				borderLenght = (int)System.Math.Pow(2,baumtiefe);
				for (int i=0; i< borderLenght; i++)
				{
					for (int j=0; j< borderLenght; j++)
					{
						for (int k=0; k< borderLenght; k++)
						{
							if(leafs[i,j,k].lastChange0>=leafs[i,j,k].lastChange1)
								leafs[i,j,k].state[1] =leafs[i,j,k].state[0];
							else
								leafs[i,j,k].state[0] =leafs[i,j,k].state[1];

							leafs[i,j,k].lastChange0=0;
							leafs[i,j,k].lastChange1=7;
							leafs[i,j,k].touchTimeStamp=7;
						}
					}
				}
			}
			return changed;
		}

		

		

		public byte MoveDown(int l,int x, int y,int z,ref bool changed)
		{
			int borderLenght =(int)System.Math.Pow(2,l);
			int xo = x + borderLenght;
			int yo = y + borderLenght;
			int zo = z + borderLenght;
			bool[,,] childs = new bool[2,2,2];
			ArrayList updRates = new ArrayList();
			bool changedB =false;

			if ( (runCounter %(nodeBaum[l][x,y,z]).updRate)==0)
			{
				if (!(  (nodeBaum[l][x,y,z].lastChange0==nodeBaum[l][x,y,z].touchTimeStamp)
					||(nodeBaum[l][x,y,z].lastChange1==nodeBaum[l][x,y,z].touchTimeStamp)))
				{
					conections( x, y, z, xo, yo, zo, borderLenght,l,childs);
				}
				else
				{
					childs[0,0,0] = true;
					childs[0,0,1] = true;
					childs[0,1,0] = true;
					childs[0,1,1] = true;
					childs[1,0,0] = true;
					childs[1,0,1] = true;
					childs[1,1,0] = true;
					childs[1,1,1] = true;
				}


				if (l+1 < baumtiefe)
				{
					
					if(childs[0,0,0])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x,2*y,2*z,ref changedB));
						changed = changed | changedB;						
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x,2*y,2*z].updRate);
					}
					if(childs[0,0,1])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x,2*y,2*z+1,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x,2*y,2*z+1].updRate);
					}
					if(childs[0,1,0])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x,2*y+1,2*z,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x,2*y+1,2*z].updRate);
					}
					if(childs[0,1,1])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x,2*y+1,2*z+1,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x,2*y+1,2*z+1].updRate);
					}
					if(childs[1,0,0])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x+1,2*y,2*z,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x+1,2*y,2*z].updRate);
					}
					if(childs[1,0,1])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x+1,2*y,2*z+1,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x+1,2*y,2*z+1].updRate);
					}
					if(childs[1,1,0])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x+1,2*y+1,2*z,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x+1,2*y+1,2*z].updRate);
					}
					if(childs[1,1,1])
					{
						changedB=false;
						updRates.Add (MoveDown(l+1,2*x+1,2*y+1,2*z+1,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (nodeBaum[l+1][2*x+1,2*y+1,2*z+1].updRate);
					}
					
					updRates.Sort();
					nodeBaum[l][x,y,z].updRate = (byte)updRates[0];
					nodeBaum[l][x,y,z].touchTimeStamp=runCounter;
					if(changed)
					{
						if(nodeBaum[l][x,y,z].lastChange1>=nodeBaum[l][x,y,z].lastChange0)
							nodeBaum[l][x,y,z].lastChange0=runCounter;
						else
							nodeBaum[l][x,y,z].lastChange1=runCounter;
					}
					return (byte)updRates[0];
					
					
				}
				else
				{
					CellLeaf[,,] neigField	=new CellLeaf[3,3,3];
					if(childs[0,0,0])
					{
						neighbourfield(2*x, 2*y, 2*z, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x,2*y,2*z].updRate);
					}
					if(childs[0,0,1])
					{
						neighbourfield(2*x,2*y,2*z+1, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x,2*y,2*z+1].updRate);
					}
					if(childs[0,1,0])
					{
						neighbourfield(2*x,2*y+1,2*z, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x,2*y+1,2*z].updRate);
					}
					if(childs[0,1,1])
					{
						neighbourfield(2*x,2*y+1,2*z+1, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x,2*y+1,2*z+1].updRate);
					}

					if(childs[1,0,0])
					{
						neighbourfield(2*x+1,2*y,2*z, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x+1,2*y,2*z].updRate);
					}
					if(childs[1,0,1])
					{
						neighbourfield(2*x+1,2*y,2*z+1, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x+1,2*y,2*z+1].updRate);
					}
					if(childs[1,1,0])
					{
						neighbourfield(2*x+1,2*y+1,2*z, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x+1,2*y+1,2*z].updRate);
					}
					if(childs[1,1,1])
					{
						neighbourfield(2*x+1,2*y+1,2*z+1, ref neigField);
						changedB=false;
						updRates.Add (Update(ref neigField,ref changedB));
						changed = changed | changedB;
					}
					else
					{
						updRates.Add (leafs[2*x+1,2*y+1,2*z+1].updRate);
					}
					updRates.Sort();
					nodeBaum[l][x,y,z].updRate = (byte)updRates[0];
					nodeBaum[l][x,y,z].touchTimeStamp=runCounter;
					if(changed)
					{
						if(nodeBaum[l][x,y,z].lastChange1>=nodeBaum[l][x,y,z].lastChange0)
							nodeBaum[l][x,y,z].lastChange0=runCounter;
						else
							nodeBaum[l][x,y,z].lastChange1=runCounter;
					}
					return (byte)updRates[0];

				}
			}
			else
			{
				changed=true;
				return nodeBaum[l][x,y,z].updRate;
			}
		}
		private void CheckNeiBRight (int x, int y, int z, int xo, int yo, int zo, int borderLenght,int l,bool[,,] childs)
		{
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo)%borderLenght,(zo)%borderLenght))
			{
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void CheckNeiBLeft (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo)%borderLenght,      (zo)%borderLenght))
			{
				childs[0, 0, 0]=true;
				childs[0, 0, 1]=true;
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
			}
		}
		private void CheckNeiBTop (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo+1)%borderLenght,      (zo)%borderLenght))
			{
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void CheckNeiBBotton (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo-1)%borderLenght,      (zo)%borderLenght))
			{
				childs[0, 0, 0]=true;
				childs[0, 0, 1]=true;
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
			}
		}
		private void CheckNeiBBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo)%borderLenght,      (zo+1)%borderLenght))
			{
				childs[0, 0, 1]=true;
				childs[0, 1, 1]=true;
				childs[1, 0, 1]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void CheckNeiBFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{
			
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo)%borderLenght,      (zo-1)%borderLenght))
			{
				childs[0, 0, 0]=true;
				childs[0, 1, 0]=true;
				childs[1, 0, 0]=true;
				childs[1, 1, 0]=true;
			}
		}
		private void CheckNeiBBordLeftFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{
		
			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo)%borderLenght,       (zo-1)%borderLenght))
			{
				childs[0, 1, 0]=true;
				childs[0, 0, 0]=true;
			}
		}

		private void CheckNeiBBordLeftBotton (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{


			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo-1)%borderLenght,       (zo)%borderLenght))
			{
				childs[0, 0, 1]=true;
				childs[0, 0, 0]=true;
			}
		}
		private void CheckNeiBBordLeftBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[0, 1, 1]=true;
				childs[0, 0, 1]=true;
			}
		}
		private void CheckNeiBBordLeftTop (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo+1)%borderLenght,       (zo)%borderLenght))
			{
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
			}
		}
		private void CheckNeiBBordRightBotton (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo-1)%borderLenght,       (zo)%borderLenght))
			{
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
			}
		}

		private void CheckNeiBBordRightBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[1, 0, 1]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void CheckNeiBBordRightFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo)%borderLenght,       (zo-1)%borderLenght))
			{
				childs[1, 0, 0]=true;
				childs[1, 1, 0]=true;
			}
		}
		

		private void CheckNeiBBordRightTop (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo+1)%borderLenght,       (zo)%borderLenght))
			{
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void CheckNeiBBordTopBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo+1)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[0, 1, 1]=true;
				childs[1, 1, 1]=true;
			}
		}
		
		private void CheckNeiBBordTopFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo+1)%borderLenght,      (zo-1)%borderLenght))
			{
				childs[0, 1, 0]=true;
				childs[1, 1, 0]=true;
			}
		}
		private void CheckNeiBBordBottonBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{


			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo-1)%borderLenght,      (zo+1)%borderLenght))
			{
				childs[0, 0, 1]=true;
				childs[1, 0, 1]=true;
			}
		}
		private void CheckNeiBBordBottonFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght,
				(yo-1)%borderLenght,      (zo-1)%borderLenght))
			{
				childs[0, 0, 0]=true;
				childs[1, 0, 0]=true;
			}
		}
		private void CheckNeiBCorLeftTopBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo+1)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[0, 1, 1]=true;
			}
		}
		private void CheckNeiBCornLeftTopFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo+1)%borderLenght,       (zo-1)%borderLenght))
			{
				childs[0, 1, 0]=true;
			}
		}
				
		private void CheckNeiBCorLeftBottonBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo-1)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[0, 0, 1]=true;
			}
		}
		private void CheckNeiBCorLeftBottonFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght,
				(yo-1)%borderLenght,       (zo-1)%borderLenght))
			{
				childs[0, 0, 0]=true;
			}
		}
		
		private void CheckNeiBCorRightTopBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo+1)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[1, 1, 1]=true;
			}
		}
		private void CheckNeiBCroRightTopFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo+1)%borderLenght,       (zo-1)%borderLenght))
			{
				childs[1, 1, 0]=true;
			}
		}
		private void CheckNeiBCorRightBottonBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo-1)%borderLenght,       (zo+1)%borderLenght))
			{
				childs[1, 0, 1]=true;
			}
		}
		private void CheckNeiBCorRightBottonFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,bool[,,] childs)
		{

			if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght,
				(yo-1)%borderLenght,       (zo-1)%borderLenght))
			{
				childs[1, 0, 0]=true;
			}
		}
		private void neighbourfield(int x, int y, int z, ref CellLeaf[,,] neigField)
		{
			int borderLLeaf =(int)System.Math.Pow(2,baumtiefe);
			int xo = x + borderLLeaf;
			int yo = y + borderLLeaf;
			int zo = z + borderLLeaf;
			for(int i=-1;i<2;i++)
			{
				for(int j=-1;j<2;j++)
				{
					for(int k=-1;k<2;k++)
					{
						neigField[i+1,j+1,k+1]=leafs[(xo+i)%borderLLeaf,(yo+j)%borderLLeaf,(zo+k)%borderLLeaf];
					}
				}
			}
	
		}
		private bool NodeNeighbourChanged(ushort MeTTS, int l, int x, int y, int z)
		{
			if(((runCounter>nodeBaum[l][x,y,z].lastChange0)&& (nodeBaum[l][x,y,z].lastChange0>=MeTTS))
				||((runCounter>nodeBaum[l][x,y,z].lastChange1)&& (nodeBaum[l][x,y,z].lastChange1>=MeTTS)))
				return true;
			else	
				return false;
		}

		private int LeafDataIndexActiv(ref CellLeaf[,,] neigField, int x, int y, int z)
		{
			if (neigField[x,y,z].touchTimeStamp==runCounter)
			{
				if(neigField[x,y,z].lastChange0>=neigField[x,y,z].lastChange1)
					return 1;
				else
					return 0;

			}
			else
			{
				if(neigField[x,y,z].lastChange0>=neigField[x,y,z].lastChange1)
					return 0;
				else
					return 1;
			}
		}
				


		private byte Update(ref CellLeaf[,,] neigField,ref bool changed)

		{
			
			if((runCounter%neigField[1, 1, 1].updRate)==0)
			{
				int count = 0;

				for(int i = 0; i<3; i++)
					for(int j = 0; j<3; j++)
						for(int k = 0; k<3; k++)
						{
							if(neigField[i, j, k].state[LeafDataIndexActiv(ref neigField, i, j, k)])
							{
								count++;
							}
						}
			

				if(count>0)
				{
					neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=true;

					if(!neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)])
					{
						neigField[1, 1, 1].updRate=1;
						changed=true;

						if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
							neigField[1, 1, 1].lastChange0=runCounter;
						else
							neigField[1, 1, 1].lastChange0=runCounter;
					}
					else
					{
						changed=false;
					}

					neigField[1, 1, 1].touchTimeStamp=runCounter;
					return 1;
				}
				else
				{
					neigField[1, 1, 1].updRate=1;
					changed=false;
					neigField[1, 1, 1].touchTimeStamp=runCounter;
					return neigField[1, 1, 1].updRate;
				}
			}
			else
			{
				changed=true;
				return neigField[1, 1, 1].updRate;
			}

			/*
				 if((runCounter%neigField[1, 1, 1].updRate)==0)
				 {	
					 if(neigField[0, 2, 0].state[LeafDataIndexActiv(ref neigField, 0, 2, 0)])
					 {
						 neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=true;
						 if(!neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)])
						 {
							 neigField[1, 1, 1].updRate=1;
							 changed=true;

							 if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
								 neigField[1, 1, 1].lastChange0=runCounter;
							 else
								 neigField[1, 1, 1].lastChange0=runCounter;
						 }
						 else
						 {
							 changed=false;
						 }

						 neigField[1, 1, 1].touchTimeStamp=runCounter;
						 return 1;
					 }
					 else
					 {
						 if(!neigField[0, 2, 0].state[LeafDataIndexActiv(ref neigField, 0, 2, 0)])
						 {
							 neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=false;
							 if(neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)])
							 {
								 neigField[1, 1, 1].updRate=1;
								 changed=true;

								 if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
									 neigField[1, 1, 1].lastChange0=runCounter;
								 else
									 neigField[1, 1, 1].lastChange0=runCounter;
							 }
							 else
							 {
								 changed=false;
							 }

							 neigField[1, 1, 1].touchTimeStamp=runCounter;
							 return 1;
						 }
						 else
						 {
							 neigField[1, 1, 1].updRate=1;
							 changed=false;
							 neigField[1, 1, 1].touchTimeStamp=runCounter;
							 return neigField[1, 1, 1].updRate;

						 }
					 }

		

				
				
		
			
				 }
				 else
				 {
					 changed=true;
					 return neigField[1, 1, 1].updRate;
				 }*/
		
		}
	}
		
}



